#version 330

uniform mat4 prevMVPMatrix;
uniform mat4 mvpMatrix;
uniform mat4 mvMatrix;
uniform mat3 normalMatrix;
uniform vec3 vLightPosition;
uniform mat4 lightMatrix;

in vec4 vVertex;
in vec3 vNormal;
in vec2 vTexture0;

// Color to fragment program
out vec3 vVaryingNormal;
out vec3 vVaryingLightDir;
out vec2 vTexCoords;
out vec4 projCoord;

//out vec3 speedInfo;
//out vec2 speed;

out vec4 curPos;
out vec4 prevPos;

void main(void) 
{ 
	// Get surface normal in eye coordinates
	vVaryingNormal = normalMatrix * vNormal;

	// Get vertex position in eye coordinates
	vec4 vPosition4 = mvMatrix * vVertex;
	vec3 vPosition3 = vPosition4.xyz / vPosition4.w;

	// Get vector to light source
	vVaryingLightDir = normalize(vLightPosition - vPosition3);

	// Pass along the texture coordinates
	vTexCoords = vTexture0;

	projCoord = lightMatrix * vVertex;

	//vec4 curPos = mvpMatrix * vVertex;
	//vec4 prevPos = prevMVPMatrix * vVertex;

	curPos = mvpMatrix * vVertex;
	prevPos = prevMVPMatrix * vVertex;

	//speed = (curPos.xy / curPos.w) - (prevPos.xy / prevPos.w);
	//speed *= 5;
	//speedInfo = vec3(normalize(speed), length(speed));

	gl_Position = curPos;
}
