#version 330           

// uniform shader-parameters
uniform vec3 lightPos;
uniform vec4 lightColor;
uniform vec4 ambientColor;

// fragment-shader input variables
in vec4 fragColor;
in vec3 worldNormal;
in vec4 worldPos;

out vec4 fragColorOut;

void main()
{
	// renormalize and homogenize input variables
	vec3 normal = normalize(worldNormal);
    vec3 position = worldPos.xyz / worldPos.w;
    
    // calculate the light-direction
    vec3 light_dir = normalize(lightPos - position);

	// calculate lighting
    vec4 ambient = ambientColor * fragColor;
    vec4 diffuse = fragColor * lightColor * max(0.0, dot(normal, light_dir));
    
    // write color to output
    fragColorOut = ambient + diffuse;
}
