#version 330             

// uniform shader-parameters
uniform mat4 mvp;
uniform mat4 model;

// vertex-shader input variables
in vec4 vertex;
in vec4 color;
in vec3 normal;

// vertex-shader output variables (passed to fragment-shader)
out vec4 fragColor;
out vec3 worldNormal;
out vec4 worldPos;

void main()
{
	fragColor = color;			  // pass color to fragment-shader
	
	// transform normal into world space
	vec4 normal4 = vec4(normal, 0.0f);
    worldNormal = (model * normal4).xyz;
    
    // transform vertex to world-space
    worldPos = model * vertex;

    // transform vertex down the pipeline
    gl_Position = mvp * vertex;
}
